基于vb 的solidworks 二次开发解决方案

基于vb 的solidworks 二次开发
Option Explicit

Private Sub command1_click()
Dim swApp As SldWorks.SldWorks
Dim swModel As ModelDoc2
Dim swDocExt As ModelDocExtension
Dim swAssy As AssemblyDoc
Dim tmpPath As String
Dim tmpObj As SldWorks.ModelDoc2
Dim boolstat As Boolean
Dim strings As Variant
Dim swcomponent As SldWorks.Component2
Dim matefeature As SldWorks.Feature
Dim MateName As String
Dim FirstSelection As String
Dim SecondSelection As String
Dim Alignment As swMateAlign_e
Dim strCompName As String
Dim AssemblyTitle As String
Dim AssemblyName As String
Dim errors As Long
Dim warnings As Long
Dim mateError As Long
Set swApp = CreateObject("SldWorks.Application")
Set swModel = swApp.ActiveDoc
' Get title of assembly document
AssemblyTitle = swModel.GetTitle
' Split the title into two strings using the period (.) as the delimiter
strings = Split(AssemblyTitle, ".")
' You'll use AssemblyName when mating the component with the assembly
AssemblyName = strings(0)
Debug.Print AssemblyName
boolstat = True
Dim strCompModelname As String
strCompModelname = "零件2.sldprt"
' Because the component resides in the same folder as the assembly, get
' the assembly's path and use it when opening the component
tmpPath = Left(swModel.GetPathName, InStrRev(swModel.GetPathName, "\"))
' Open the component
Set tmpObj = swApp.OpenDoc6(tmpPath + strCompModelname, swDocPART, 0, "", errors, warnings)
' Check to see if the file is read-only or cannot be found; display error
' messages if either
If warnings = swFileLoadWarning_ReadOnly Then
MsgBox "This file is read-only."
boolstat = False
End If
If tmpObj Is Nothing Then
MsgBox "Cannot locate the file."
boolstat = False
End If
'Re-activate the assembly so that you can add the component to it
Set swModel = swApp.ActivateDoc2(AssemblyTitle, True, errors)
Set swAssy = swModel
' Add the camtest part to the assembly document.
' Currently only one option, swAddComponentConfigOptions_e.swAddComponentConfigOptions_CurrentSelectedConfig,
' works for adding a part using AddComponent5. The other options, swAddComponentConfigOptions_e.swAddComponentConfigOptions_NewConfigWithAllReferenceModels and
' swAddComponentConfigOptions_e.swAddComponentConfigOptions_NewConfigWithAsmStructure, work only for adding assemblies using AddComponent5.
Set swcomponent = swAssy.AddComponent5(strCompModelname, swAddComponentConfigOptions_CurrentSelectedConfig, "", False, "", -1, -1, -1)
' Get the name of the component for the mate
strCompName = swcomponent.Name2()
' Create the name of the mate and the names of the planes to use for the mate
MateName = "mymate_" + strCompName
FirstSelection = "前视基准面@" + strCompName & "@" + AssemblyName
SecondSelection = "前视基准面@" + AssemblyName

Set swDocExt = swModel.Extension
swModel.ClearSelection2 (True)
' Select the planes for the mate
boolstat = swDocExt.SelectByID2(FirstSelection, "FACE", 0, 0, 0, True, 1, Nothing, swSelectOptionDefault)
boolstat = swDocExt.SelectByID2(SecondSelection, "FACE", 0, 0, 0, True, 1, Nothing, swSelectOptionDefault)
' Add the mate

Set matefeature = swAssy.AddMate3(swMateCOINCIDENT, swMateAlignALIGNED, False, 0, 0, 0, 0, 0, 0, 0, 0, False, mateError)
'If Not matefeature Is Nothing Then
matefeature.Name = MateName
'swModel.ViewZoomtofit2
'Else
'MsgBox ("配合错误!请检查程序")
'
'End If
end
这是solidworks二次开发中给出的例子。我修改后为什么总是红色部分出错。怎么也找不到问题。希望高手给看看。绿色的部分应该是对的吧
------解决方案--------------------
那就是你红色语句之前的那一句:
Set matefeature = swAssy.AddMate3(swMateCOINCIDENT, ............)
未能成功执行,返回值为 Nothing 呀。

------解决方案--------------------
Set matefeature = swAssy.AddMate3
添加没有成功,返回的应该是Nothing

Set matefeature = swAssy.AddMate3
if not matefeature is nothing then'一般需要加人判断